/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.ImagemDAO;
import com.rjconsultores.ventaboletos.entidad.Imagem;
import com.rjconsultores.ventaboletos.service.ImagemService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("imagemService")
public class ImagemServiceImpl implements ImagemService {

	@Autowired
	private ImagemDAO imagemDAO;

	public List<Imagem> obtenerTodos() {
		return imagemDAO.obtenerTodos();
	}

	public Imagem obtenerID(Integer id) {
		return imagemDAO.obtenerID(id);
	}

	@Transactional(propagation = Propagation.SUPPORTS)
	public Imagem suscribir(Imagem entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado() != null ? UsuarioLogado.getUsuarioLogado().getUsuarioId() : null);
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return imagemDAO.suscribir(entidad);
	}

	@Transactional
	public Imagem actualizacion(Imagem entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return imagemDAO.actualizacion(entidad);
	}

	@Transactional
	public void borrar(Imagem entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		imagemDAO.actualizacion(entidad);
	}

	@Transactional(readOnly = true, propagation = Propagation.SUPPORTS)
	public Imagem buscarPorNomeImagem(String nomeImagem) {
		return imagemDAO.buscarPorNomeImagem(nomeImagem);
	}

	public List<Imagem> buscar(String nombimagem) {
		return imagemDAO.buscar(nombimagem);
	}

}
